package org.netkernel.layer0.meta.impl;

import java.util.*;

import org.netkernel.container.IMessages;
import org.netkernel.layer0.bnf.BNFGrammarFactory;
import org.netkernel.layer0.bnf.GrammarParseException;
import org.netkernel.layer0.bnf.IGrammarGroup;
import org.netkernel.layer0.meta.IEndpointArgumentMeta;
import org.netkernel.layer0.meta.IEndpointMeta;
import org.netkernel.request.IRequest;


public class TransreptorMetaBuilder2 extends EndpointMetaBuilder
{
	private List mFromClasses;
	
	public TransreptorMetaBuilder2()
	{	setVerbs(IRequest.VERB_TRANSREPT);
		mFromClasses=new ArrayList(4);
		IGrammarGroup root=BNFGrammarFactory.createGroup(null);
		BNFGrammarFactory.createRegex(root, BNFGrammarFactory.BUILTIN_ANYTHING);
		setGrammarRoot(root);		
	}
	
	public void addFromRepresentation(Class aFrom)
	{	mFromClasses.add(aFrom);
	}
	
	public IEndpointMeta getMeta(IMessages aMessages) throws GrammarParseException
	{
		Class[] from;
		if (mFromClasses.size()!=0)
		{
			from= new Class[mFromClasses.size()];
			for (int i=0; i<from.length; i++)
			{	from[i]=(Class)mFromClasses.get(i);
			}
		}
		else
		{	from = new Class[]{Object.class};
		}
		IEndpointArgumentMeta arg= new EndpointArgumentMetaImpl(IEndpointArgumentMeta.PRIMARY_PART,null,null,null,null,false,from);
		addArgument(arg);
		
		return super.getMeta(aMessages);
	}
	
}