package org.netkernel.layer0.representation.impl;

import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSPredicate;

public class HDSPredicateFactory
{
	public static IHDSPredicate namedChildEquals(final String aChildName, final Object aValue)
	{
		return new IHDSPredicate()
		{	public boolean matches(IHDSNode aNode)
			{	boolean result;
				IHDSNode child = aNode.getFirstNode(aChildName);
				if (child!=null)
				{	Object value=child.getValue();
					if (value!=null)
					{	result = value.equals(aValue);
					}
					else
					{	result = aValue==null;
					}
				}
				else
				{	result = false;
				}
				return result;
			}
		};
	}
	
	public static IHDSPredicate namedChildStringEquals(final String aChildName, final String aValue)
	{
		return new IHDSPredicate()
		{	public boolean matches(IHDSNode aNode)
			{	boolean result;
				IHDSNode child = aNode.getFirstNode(aChildName);
				if (child!=null)
				{	Object value=child.getValue();
					if (value!=null)
					{	result = value.toString().equals(aValue);
					}
					else
					{	result = aValue==null;
					}
				}
				else
				{	result = false;
				}
				return result;
			}
		};
	}	

	public static IHDSPredicate hasChild(final String aChildName)
	{
		return new IHDSPredicate()
		{	public boolean matches(IHDSNode aNode)
			{	boolean result =  aNode.getFirstNode(aChildName)!=null;
				return result;
			}
		};
	}	

}
