package org.netkernel.layer0.urii;

import org.netkernel.layer0.bnf.IPartEncoding;

public class ActiveURIEncoding implements IPartEncoding
{
	public static final ActiveURIEncoding INSTANCE=new ActiveURIEncoding();
	
	public String decode(String aInput)
	{	char[] input = aInput.toCharArray();
		int length=input.length;
		int i;
		for (i=0; i<length; i++)
		{	if (input[i]=='%')
			{	break;
			}
		}
		if (i<length)
		{	char[] output =  new char[length];
			int l=0;
			for (i=0; i<length; i++)
			{	char r = input[i];
				if (r=='%')
				{	int c1 = toHex(input[++i]);
					int c2 = toHex(input[++i]);
					char r2 = (char)((c1<<4) + c2);
					switch (r2)
					{	case ' ':
						case '%':
						case ':':
						case '#':
						case '+':
						case '@':
						case '=':
							r=r2;
							break;
						default:
							i-=2;
							break;
					}
				}
				output[l++]=r;
			}
			return new String(output,0,l);
		}
		else
		{	return aInput;
		}
		
	}
	
	public static int toHex(char aChar)
	{	int result=0;
		if (aChar<='9' && aChar>='0')
		{	result = aChar-'0';
		}
		else if (aChar<='Z' && aChar>='A')
		{	result= aChar-('A'-10);
		}
		return result;
	}
	
	public String encode(String aInput)
	{	char[] input = aInput.toCharArray();
		int length=input.length;
		char [] output = new char[length*3];
		int l=0;
		for (int i=0; i<length; i++)
		{	char c=input[i];
			switch (c)
			{	case ' ': output[l++]='%'; output[l++]='2'; output[l++]='0'; break;
				case '%': output[l++]='%'; output[l++]='2'; output[l++]='5'; break;
				case ':': output[l++]='%'; output[l++]='3'; output[l++]='A'; break;
				case '#': output[l++]='%'; output[l++]='2'; output[l++]='3'; break;
				case '+': output[l++]='%'; output[l++]='2'; output[l++]='B'; break;
				case '@': output[l++]='%'; output[l++]='4'; output[l++]='0'; break;
				case '=': output[l++]='%'; output[l++]='3'; output[l++]='D'; break;
				default: output[l++]=c;
			}
		}
		if (l!=length)
		{	return new String(output,0,l);
		}
		else
		{	return aInput;
		}
	}
}
